#!/bin/bash

function echvhost(){
cat <<EOF
# https://nospam._DOM_:4433/ SSL server pro rizeni spamu
Listen 4433

LoadModule authnz_external_module modules/mod_authnz_external.so

<VirtualHost *:4433>
    DocumentRoot "/var/www/dspam/html"
    ServerName nospam._DOM_
    ServerAdmin webmaster@_DOM_
    ErrorLog logs/dspam._DOM_-error_log
    TransferLog logs/dspam._DOM_-access_log
    SSLEngine on
    SSLProtocol all -SSLv2
    SSLCertificateFile /etc/pki/tls/certs/dspam._DOM_.crt
    DirectoryIndex dspam.cgi
    SuexecUserGroup dspam dspam
    AddExternalAuth for-dspam /usr/bin/pwauth
    SetExternalAuthMethod for-dspam pipe
    <Files ~ "\.(cgi|shtml|phtml|php3?)$">
        SSLOptions +StdEnvVars
    </Files>
    <Directory "/var/www/dspam/html">
        AddHandler cgi-script .cgi
        Options +FollowSymLinks +ExecCGI
        AllowOverride AuthConfig
        Order deny,allow
        Deny from all
        SSLRequireSSL
        AuthType Basic
        AuthName "DSPAM Control Center"
#       AuthName "Overeni uzivatelskeho pristupu"
#       AuthUserFile /etc/httpd/dspam._DOM_/htpasswd
        AuthBasicProvider external
        AuthExternal for-dspam
        Require valid-user
        Satisfy Any
    </Directory>
</VirtualHost>
EOF
}

DD=`dnsdomainname`
[ "$DD" ] || DD=`uname -n|sed -e 's/^[^\.]\+\.\(.*\)/\1/'`
[ "$DD" ] || DD=localdomain
OF="/etc/httpd/conf.d/dspamssl.conf"
[ -f "$OF" ] && OF="$OF.rpmnew"
echvhost|sed -e 's/_DOM_/$DD/g' > "$OF"
echo "$OF zalozen"
#
if [ "$RPM_DOC_DIR" -a -f "$RPM_DOC_DIR/contrib/fedora/dspam_aliases.sh" ]; then
  DAS="$RPM_DOC_DIR/contrib/fedora/dspam_aliases.sh"
else
  DASD=$(ls -d --sort=time /usr/share/doc/dspam-* 2>/dev/null|head -n 1)
  if [ "$DASD" -a -f "$DASD/contrib/fedora/dspam_aliases.sh" ]; then
    DAS="$DASD/contrib/fedora/dspam_aliases.sh"
  else
    echo "Nemohu najit \"dspam_aliases.sh\" (byva v \"/usr/share/doc/dspam-VER/contrib/fedora/\")"
  fi
fi
if [ -f "$DAS" ]; then
  echo "Spoustim \"$DAS\"..."
  "$DAS"
else
  echo "\"$DAS\" neexistuje..."
fi  
